from GGI.ggi import Visual
from GGI.const import flagAsync, emKeyPress
from random import randint

size = None

def visual():
    global size
    v       = Visual()
    v.mode  = v.Mode()
    size    = v.mode.visible
    v.flags = flagAsync
    print v.mode
    return v

def pause(v):
    v.flush()
    v.poll(mask=emKeyPress)
    v.read(emKeyPress)

def test_pixel(v):
    for i in range(1000):
        v.putPixel(randint(0,size[0]),randint(0,size[1]), randint(0,0xfffffff))
    pause(v)
    
def test_line(v):
    for i in range(100):
        v.putLine(randint(0,size[0]),
                  randint(0,size[1]),
                  randint(0,size[0]),
                  randint(0,size[1]),
                  randint(0,0xfffffff))
    pause(v)
   
def test_hline(v):
    for i in range(50):
        v.putHLine(randint(0,size[0]),randint(0,size[1]),
                   randint(0,size[0]),randint(0,0xfffffff))
    pause(v)

def test_vline(v):
    for i in range(50):
        v.putVLine(randint(0,size[0]),randint(0,size[1]),
                   randint(0,size[1]),randint(0,0xfffffff))
    pause(v)

def test_box(v):
    for i in range(30):
        v.putBox(randint(0,size[0]),randint(0,size[1]),
                 randint(0,size[0])/2,randint(1,size[1])/2,
                 randint(0,0xfffffff))
    pause(v)


def test_pack(v):
    for i in xrange(50):
        for j in xrange(50):
            v.putPixel(i,j,[i/49.0,1-((i+j)/98.0),j/49.0])
    p=v.getBox(0,0,50,50)
    for i in xrange(10):
        v.putBox(i*60,i*20,50,50,p)

    for i in xrange(30):
        v.putHLine(i*2,i*5,100,p)
        v.putVLine(i*2,i*5,100,p)        
    pause(v)

def test_blit(v):
    for i in xrange(5):
        v.copyBox(i*10, i*15, 70, 70, (i*20)+30,(i*20)+50 )
    pause(v)

def test_crossblit(v):
    d = visual()
    for i in xrange(5):
        v.crossBlit(d, i*50, i*25, 40, 40)
    v.flush()
    d.flush()
    pause(d)

    p  = v.getBox(0,0,50,50)
    np = d.Pack(p)
    for i in xrange(10):
        d.putBox(i*60,i*20,50,50,np)
    pause(d)

v = visual()
try:
    print "Test pixels"
    test_pixel(v)
    print "Test lines"
    test_line(v)
    print "Test hlines"
    test_hline(v)
    print "Test vlines"
    test_vline(v)
    print "Test box"
    test_box(v)
    print "Test pack"
    test_pack(v)
    print "Test blit"
    test_blit(v)
    print "Test crossblit"
    test_crossblit(v)
except:
    pass

